import java.io.*;

class Main {
    public static void main(String[] args) {
        if (args.length != 2) {
            System.err.println(
                "usage: java Main <new filename> <size in bytes>");
            System.exit(-1);
        }
        long size = 0;
        try {
            size = Long.parseLong(args[1]);
        } catch (NumberFormatException e) {
            System.err.println(
                "usage: java Main <new filename> <size in bytes>");
            System.exit(-1);
        }

        try {
            RandomAccessFile raf = new RandomAccessFile(args[0], "rw");
            raf.setLength(size);     // extend file to be specified size
            raf.close();
        } catch (IOException e) {
            e.printStackTrace();
        }
    }
}
