import java.lang.reflect.*;

class Main {
    public static void main(String[] args) {
        C c = new C();

        try {
            Field f = c.getClass().getDeclaredField("i");

            System.out.println( f.isAccessible() ); // false

            // The private field is not accessible so exception occurs.
            //System.out.println( f.getInt(c) );    // IllegalAccessException

            // Make Field object accessible.
            f.setAccessible(true);
            System.out.println( f.isAccessible() ); // true
            System.out.println( f.getInt(c) );      // 10

            // Examine a public field.
            f = c.getClass().getDeclaredField("j");
            System.out.println( f.isAccessible() ); // false
            System.out.println( f.getInt(c) );      // 20
        } catch (NoSuchFieldException e) {
            e.printStackTrace();
        } catch (IllegalAccessException e) {
            e.printStackTrace();
        }
    }
}

class C {
    private int i = 10;
    public int j = 20;
}