class Main {
    public static void main(String args[]) {
        for (int i=0; i<5; i++) {
            Worker worker = new Worker();
            worker.setPriority(Thread.currentThread().getPriority()-1);

            try {
                worker.start();
                Thread.sleep(5000);    // Wait 5 seconds.

                System.out.println("Stopping thread: " + worker);

                worker.safeStop();     // Stop the thread.
            } catch (InterruptedException e) {
                e.printStackTrace();
            }
        }
    }
}

class Worker extends Thread {
    private int count;
    private boolean done = false;

    synchronized void safeStop() {
        done = true;
    }

    synchronized boolean ok() {
        return (!done);
    }
    void doWork() {
        // do something useful here
        ++count;
    }

    public void run() {
        while (ok()) {
            doWork();
        }
    }
}
