import java.net.SocketPermission;
import java.security.PermissionCollection;

public class Main {
    public static void main(String[] args) {
//
        SocketPermission[] p = new SocketPermission[3];

        // Allow connections to "*.xeo.com" subtree, including its root
        p[0] = new SocketPermission("xeo.com", "connect");
        p[1] = new SocketPermission("*.xeo.com", "connect");

        // Allow resolution of all names under .com
        p[2] = new SocketPermission("*.com", "resolve");

        PermissionCollection col = p[0].newPermissionCollection();
        for (int i = 0; i < p.length; i++) {
            col.add(p[i]);
        }

        // OK to connect to www.xeo.com?
        System.out.println(col.implies(
            new SocketPermission("www.xeo.com", "connect"))); 
                                                                // true
        // OK to connect/resolve www.xeo.com?
        System.out.println(col.implies(
            new SocketPermission("www.xeo.com:90", "connect, resolve")));
                                                                // true
        // OK to resolve www.altavista.com
        System.out.println(col.implies(
            new SocketPermission("www.altavista.com", "resolve")));
                                                                // true
        // Not OK to resolve com
        System.out.println(col.implies(
            new SocketPermission("com", "resolve")));           // false
//
    }
}
