import java.text.AttributedString;
import java.text.AttributedCharacterIterator;
import java.text.Annotation;
import java.util.Locale;

class Main {
    public static void main(String[] args) {
        // Create an attributed string.
        AttributedString attrStr = new AttributedString("Vous l'aimez.");

        // Add a French language attribute key/value pair to entire string.
        attrStr.addAttribute(
            AttributedCharacterIterator.Attribute.LANGUAGE,
            Locale.FRENCH);

        // Assign READING constant to a variable.
        AttributedCharacterIterator.Attribute attrREAD =
            AttributedCharacterIterator.Attribute.READING;

        // Add reading attribute key/value pairs for each subrange.
        attrStr.addAttribute(attrREAD, new Annotation("vu"), 0, 4);  // Vous
        attrStr.addAttribute(attrREAD, new Annotation("l"), 5, 7);   // l'
        attrStr.addAttribute(attrREAD, new Annotation("eme"), 7, 12); // aimez

        // Get the string's iterator and print the string.
        AttributedCharacterIterator iter = attrStr.getIterator();
        printText(iter);

        // Print each run of the READING attribute.
        iter.first();
        while (iter.current() != AttributedCharacterIterator.DONE) {
            printToRunLimit(iter);
        }
    }

    public static void printText(AttributedCharacterIterator aci){
        // print the entire text using the character iterator
        do {
            System.out.print(aci.current());
            aci.next();
        } while (aci.current() != AttributedCharacterIterator.DONE) ;
        System.out.println("");
    }

    // Print the run start, run limit, string and attribute value.
    public static void printToRunLimit(AttributedCharacterIterator aci) {
        // Get the run limit of the READING attribute.
        int runStart = aci.getRunStart(
            AttributedCharacterIterator.Attribute.READING);
        printInColumn("" + runStart, 5);
        int runLimit = aci.getRunLimit(
            AttributedCharacterIterator.Attribute.READING);
        printInColumn("" + runLimit, 5);
        Object attr = aci.getAttribute(
            AttributedCharacterIterator.Attribute.READING);

        // Print to the run limit
        System.out.print("\"");
        while (aci.getIndex() < runLimit) {
            System.out.print(aci.current());
            aci.next();
        }
        System.out.print("\"   ");
        printInColumn("", 10 - (runLimit - runStart));
        System.out.println(attr);
    }

    // Print string, then pad spaces to a particular vertical column
    static void printInColumn(String str, int col) {
        System.out.print(str);
        for (int p = str.length(); p < col; ++p) {
            System.out.print(" ");
        }
    }
}
