import java.text.AttributedString;
import java.text.AttributedCharacterIterator;
import java.text.Annotation;
import java.util.Locale;

class Main {
    public static void main(String[] args) {

        // Create an attributed string.
        AttributedString attrStr = new AttributedString("Vous");

        // Add a French language attribute key/value pair to entire string.
        attrStr.addAttribute(
            AttributedCharacterIterator.Attribute.LANGUAGE,
            Locale.FRENCH);

        // Assign READING constant to a variable.
        AttributedCharacterIterator.Attribute attrREAD =
            AttributedCharacterIterator.Attribute.READING;

        // Add reading attribute key/value pairs for each subrange.
        attrStr.addAttribute(attrREAD, new Annotation("vu"), 0, 4);  // Vous

        // Get the string's iterator and print the string.
        AttributedCharacterIterator iter = attrStr.getIterator();
        iter.getAttributes();

        // Print each of the keys.
        iter.first();
        System.out.println("Keys: ");
        printAttrKeys(iter);
        System.out.println("");

        // Print each of the key/value pairs.
        iter.first();
        System.out.println("Key/Value Pairs: ");
        printAttrKeyValuePairs(iter);
    }

    // Print each of the keys.
    public static void printAttrKeys(AttributedCharacterIterator aci) {
        Object[] attrArray = aci.getAllAttributeKeys().toArray();
        for(int i=0; i<attrArray.length; i++) {
            System.out.println(attrArray[i]);
        }
    }

    // Print each of the key/value pairs.
    public static void printAttrKeyValuePairs(
                                      AttributedCharacterIterator aci) {
        Object[] attrKeyArray = aci.getAttributes().keySet().toArray();
        Object[] attrValueArray = aci.getAttributes().values().toArray();
        for(int i=0; i<attrKeyArray.length; i++) {
            System.out.println(attrKeyArray[i]);
            System.out.println(attrValueArray[i]);
            System.out.println("");
        }
    }
}
