import java.util.*;

class Main {
    public static void main(String[] args) {
//
        List list = new ArrayList(Arrays.asList(new String[]{"dog", "cat"}));
        ListIterator it = list.listIterator();
        
        //it.remove();                             // IllegalStateException
        System.out.println( it.next() );           // dog
        it.remove();
        System.out.println( list );                // [cat]

        // You can't call remove() after another remove().
        //it.remove();                             // IllegalStateException

        // You also can't call remove() after add().
        it.add("pig");
        System.out.println( list );                // [pig, cat]
        //it.remove();                             // IllegalStateException

        // But you can remove an element that's just been set.
        System.out.println( it.next() );           // cat
        it.set("dog");
        it.remove();                             
        System.out.println( list );                // [pig]

        System.out.println( it.next() );           // IllegalStateException
        System.out.println( it.previous() );       // pig

        // Remove the previous element.
        it.remove();
        System.out.println( list );                // []

        // Remove all null elements.
        list = new ArrayList(Arrays.asList(new String[]{"dog", null, "cat"}));
        for (ListIterator i=list.listIterator(); i.hasNext(); ) {
            if (i.next() == null) {
                i.remove();
            }
        }
        System.out.println( list );                // [dog, cat]
//
    }
}
