import java.util.*;

class Main {
    public static void main(String[] args) {
        System.out.println(union(Collections.singleton("dog"),
            Collections.singleton("cat")));
        System.out.println(intersection(Collections.singleton("dog"),
            Collections.singleton("cat")));
    }

//
    public static Set union(Set s1, Set s2) {
        Set result;
        if (s1 instanceof SortedSet) {
            result = new TreeSet(s1);
            result.addAll(s2);
        } else if (s2 instanceof SortedSet) {
            result = new TreeSet(s2);
            result.addAll(s1);
        } else {
            result = new HashSet(s1);
            result.addAll(s2);
        }
        return result;
    }

    public static Set intersection(Set s1, Set s2) {
        Set result;
        if (s1 instanceof SortedSet) {
            result = new TreeSet(s1);
            result.retainAll(s2);
        } else if (s2 instanceof SortedSet) {
            result = new TreeSet(s2);
            result.retainAll(s1);
        } else {
            result = new HashSet(s1);
            result.retainAll(s2);
        }
        return result;
    }
//
}