import java.io.*;
import java.util.*;
import java.util.jar.*;

class Main {
    public static void main(String[] args) {
        if (args.length < 1) {
            System.out.println("Usage: java Main <manifest-file>");
            System.exit(1);
        }

        try {
            printManifest(new Manifest(new FileInputStream(args[0])));
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    static void printManifest(Manifest man) {
        System.out.println("---------- Main Attributes");
        printAttributes(man.getMainAttributes());
        for (Iterator it=man.getEntries().keySet().iterator(); it.hasNext();) {
            String ename = (String)it.next();
            System.out.println("---------- " + ename);
            printAttributes(man.getAttributes(ename));
        }
    }

    static void printAttributes(Attributes attr) {
        for (Iterator it=attr.keySet().iterator(); it.hasNext(); ) {
            Object key = it.next();
            System.out.println(key + ": " + attr.get(key));
        }
    }
}
